<template>
    <div class="row" v-if="addMode">
        <div class="col-auto">
            <label for="yearInput" class="col-form-label">Год</label>
            <input class="form-control" id="yearInput" type="number" min="2014" max="2030" required v-model="newBudget.year">
        </div>
        <div class="col-auto">
            <label for="typeInput" class="col-form-label">Тип</label>
            <select id="typeInput" class="form-select" v-model="newBudget.type">
                <option v-for="budgetType in budgetTypes"
                    :key="budgetType.id"
                    :value="budgetType.value">
                    {{budgetType.name}}
                </option>
            </select>
        </div>
        <div class="col-auto">
            <label for="nameInput" class="col-form-label">Название</label>
            <input class="form-control" id="nameInput" v-model="newBudget.name">
        </div>
        <div class="col-auto">
            <label for="dateInput" class="col-form-label">Дата</label>
            <v-date-picker
                mode="date"
                :model-config="datepickerModelConfig"
                :timezone="datepickerTimezone"
                v-model="newBudget.date">
                <template v-slot="{ inputValue, inputEvents }">
                    <input class="form-control"
                        :value="inputValue"
                        v-on="inputEvents"/>
                </template>
            </v-date-picker>
        </div>
        <div class="col-auto mt-auto">
            <button type="button" class="btn btn-default" @click="addBudget">
                Добавить
                <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-plus-square" viewBox="0 0 16 16">
                    <path fill-rule="evenodd" d="M14 1H2a1 1 0 0 0-1 1v12a1 1 0 0 0 1 1h12a1 1 0 0 0 1-1V2a1 1 0 0 0-1-1zM2 0a2 2 0 0 0-2 2v12a2 2 0 0 0 2 2h12a2 2 0 0 0 2-2V2a2 2 0 0 0-2-2H2z"/>
                    <path fill-rule="evenodd" d="M8 4a.5.5 0 0 1 .5.5v3h3a.5.5 0 0 1 0 1h-3v3a.5.5 0 0 1-1 0v-3h-3a.5.5 0 0 1 0-1h3v-3A.5.5 0 0 1 8 4z"/>
                </svg>
            </button>
            <button type="button" class="btn btn-default" @click="deactivateAddMode">
                <svg width="1em" height="1em" viewBox="0 0 16 16" class="bi bi-slash-circle text-danger" fill="currentColor" xmlns="http://www.w3.org/2000/svg">
                    <path fill-rule="evenodd" d="M8 15A7 7 0 1 0 8 1a7 7 0 0 0 0 14zm0 1A8 8 0 1 0 8 0a8 8 0 0 0 0 16z"/>
                    <path fill-rule="evenodd" d="M11.354 4.646a.5.5 0 0 1 0 .708l-6 6a.5.5 0 0 1-.708-.708l6-6a.5.5 0 0 1 .708 0z"/>
                </svg>
            </button>
        </div>
    </div>
    <div class="row" v-else>
        <div class="col-12">
            <button type="button" class="btn btn-default" @click="activateAddMode">
                Добавить бюджет
                <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-plus-square" viewBox="0 0 16 16">
                    <path fill-rule="evenodd" d="M14 1H2a1 1 0 0 0-1 1v12a1 1 0 0 0 1 1h12a1 1 0 0 0 1-1V2a1 1 0 0 0-1-1zM2 0a2 2 0 0 0-2 2v12a2 2 0 0 0 2 2h12a2 2 0 0 0 2-2V2a2 2 0 0 0-2-2H2z"/>
                    <path fill-rule="evenodd" d="M8 4a.5.5 0 0 1 .5.5v3h3a.5.5 0 0 1 0 1h-3v3a.5.5 0 0 1-1 0v-3h-3a.5.5 0 0 1 0-1h3v-3A.5.5 0 0 1 8 4z"/>
                </svg>
        </button>
        </div>
    </div>
</template>

<script>
    import { BudgetDetailsService } from '../../services/budgetDetailsService'
    import { BudgetTypesService } from '../../services/budgetTypesService'
    import { defaultHandleErrorFunction } from '@/services/http-common'

    export default {
        name: 'BudgetDetailsAdd',
        props: {
            municipalityId: Number
        },
        emits: [ 'budgetAdded' ],
        data() {
            return {
                addMode: false,
                newBudget: {
                    type: "",
                    name: "",
                    year: 0,
                    date: new Date(),
                },
                budgetTypes: []
            }
        },
        methods: {
            activateAddMode() {
                this.newBudget = {
                    type: "",
                    name: "",
                    year: new Date().getFullYear(),
                    date: new Date(),
                };
                this.addMode = true;
            },
            addBudget() {
                const budgetDetailsService = new BudgetDetailsService();
                budgetDetailsService
                    .create({
                        MunicipalityId: this.municipalityId,
                        Type: this.newBudget.type,
                        Name: this.newBudget.name,
                        Year: this.newBudget.year,
                        Date: this.newBudget.date
                    })
                    .then(response => this.$emit('budgetAdded'))
                    .catch(defaultHandleErrorFunction);
                this.deactivateAddMode();
            },
            deactivateAddMode() {
                this.addMode = false;
            },
            getBudgetTypes() {
                new BudgetTypesService()
                    .get()
                    .then(response => this.budgetTypes = response.data)
                    .catch(defaultHandleErrorFunction);
            }
        },
        created() {
            this.getBudgetTypes();
            this.datepickerModelConfig = {
                timeAdjust: '12:00:00'
            },
            this.datepickerTimezone = 'UTC'
        }
    };
</script>